#!/bin/sh
# $Id: dosbox.SlackBuild,v 1.11 2013/10/15 13:17:39 root Exp root $
# Copyright 2005, 2006, 2007, 2009, 2010, 2012, 2013, 2021  Eric Hameleers, Eindhoven, NL
#
#  Permission to use, copy, modify, and distribute this software for
#  any purpose with or without fee is hereby granted, provided that
#  the above copyright notice and this permission notice appear in all
#  copies.
#
#  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#  SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:        Eric Hameleers <alien@slackware.com>
# For:       dosbox
# Descr:     A PC emulator with builtin DOS for running DOS Games
# URL:       http://dosbox.sourceforge.net/
# Needs:     SDL_sound
# Changelog:
# 0.63-1:   28/Oct/2005 by Eric Hameleers <alien@slackware.com>
#            * Initial build.
# 0.65-1:   28/jul/2006 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 0.70-1:   29/apr/2007 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 0.71-1:   02/aug/2007 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 0.72-1:   03/sep/2007 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 0.72-2:   03/sep/2007 by Eric Hameleers <alien@slackware.com>
#            * SlackBuild script updates 
# 0.73-1:   28/may/2009 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 0.74-1:   03/jun/2010 by Eric Hameleers <alien@slackware.com>
#            * Update.
# r3779-1:  13/apr/2012 by Eric Hameleers <alien@slackware.com>
#            * Use a SVN snapshot for the Wine-specific changes this contains.
# r3833-1:  15/oct/2013 by Eric Hameleers <alien@slackware.com>
#            * Newer SVN snapshot.
# 0.74-3-1: 30/dec/2021 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 
# Run 'sh dosbox.SlackBuild' to build a Slackware package.
# The package (.tgz) plus descriptive .txt file are created in /tmp .
# Install using 'installpkg'. 
#
# -----------------------------------------------------------------------------

# Set initial variables:

PRGNAM=dosbox
VERSION=${VERSION:-"0.74.3"}
SRCVER=${SRCVER:-"0.74-3"}
BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
TAG=${TAG:-alien}

DOCS="AUTHORS COPYING ChangeLog INSTALL NEWS README THANKS TODO \
      docs/README.video"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE="${SRCDIR}/${PRGNAM}-${SRCVER}.tar.gz"
SRCURL="https://downloads.sourceforge.net/${PRGNAM}/${PRGNAM}-${SRCVER}.tar.gz"
#SRCURL=""

# Use the src_checkout() function if no downloadable tarball exists.
# This function checks out sources from SVN/CVS and creates a tarball of them.
src_checkout() {
  # Param #1 : index in the SOURCE[] array.
  # Param #2 : full path to where SOURCE[$1] tarball should be created.
  # Determine the tarball extension:
  PEXT=$(echo "${2}" | sed -r -e 's/.*[^.].(tar.xz|tar.gz|tar.bz2|tgz).*/\1/')
  case "$PEXT" in
    "tar.xz") TARCOMP="J" ;;
    "tar.gz") TARCOMP="z" ;;
    "tgz") TARCOMP="z" ;;
    "tar.bz2") TARCOMP="j" ;;
    *) echo "Archive can only have extension 'tar.xz', '.tar.gz' '.tar.bz2' or '.tgz'" ; exit 1 ;;
  esac
  # Determine the directory name to create for the archive root:
  PBASE=$(basename ${2} .${PEXT})
  # Determine the directory where we create our checkout:
  CODIR=$(dirname ${2})
  case ${1} in
  0) # This example assumes a SVN checkout:
     if [ "$(echo ${VERSION}|cut -c1)" == 'r' ]; then # revision instead of date
       REV=$(echo ${VERSION} | cut -c2-)
     else
       REV="{${VERSION}}"
     fi
     RETDIR=$(pwd)
     mkdir -p $CODIR/${PRGNAM}_temp_checkout_$$ \
       && cd $CODIR/${PRGNAM}_temp_checkout_$$
     mkdir ${PBASE} \
       && cd ${PBASE} \
       && svn checkout  --revision $REV https://dosbox.svn.sourceforge.net/svnroot/dosbox/dosbox/trunk . \
       && find . -type d -name '.svn' -depth | xargs rm -rf \
       && chown -R root:root . \
       && cd .. \
       && tar -${TARCOMP}cf ${2} ${PBASE}
     cd $RETDIR
     rm -rf $CODIR/${PRGNAM}_temp_checkout_$$ || true
     ;;
  *) # Do nothing
     ;;
  esac
}

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
  case "$(uname -m)" in
    i?86) ARCH=i586 ;;
    arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *) ARCH=$(uname -m) ;;
  esac
  export ARCH
fi

# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
case "$ARCH" in
  i?86)      SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS=${SLKCFLAGS:-"-O2"}
             SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
             ;;
esac

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line $LINENO!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
if ! [ -f ${SOURCE} ]; then
  echo "Source '$(basename ${SOURCE})' not available yet..."
  # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
  [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename ${SOURCE})"
  if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
  if ! [ "x${SRCURL}" == "x" ]; then
    echo "Will download file to $(dirname $SOURCE)"
    wget --no-check-certificate -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
    if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
      echo "Fail to download '$(basename ${SOURCE})'. Aborting the build."
      mv -f "${SOURCE}" "${SOURCE}".FAIL
      exit 1
    fi
  else
    # Try if we have a SVN/CVS download routine for ${SOURCE}
    echo "Will checkout sources to $(dirname $SOURCE)"
    src_checkout 0 "${SOURCE}" 2>&1 > $OUTPUT/checkout-$(basename ${SOURCE}).log
  fi
  if [ ! -f "${SOURCE}" -o ! -s "${SOURCE}" ]; then
    echo "File '$(basename ${SOURCE})' not available. Aborting the build."
    exit 1
  fi
fi

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# Package building process:
echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $PKG

# Explode the package framework:
if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
  explodepkg $SRCDIR/_$PRGNAM.tar.gz
fi

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar -xvf ${SOURCE}
cd ${PRGNAM}-${SRCVER}

# Patch to solve problems with the keyboard,
# where it appears as if you stopped pressing a key:
cat $SRCDIR/patches/dosbox_events.patch | patch -p0 --verbose \
  2>&1 | tee $OUTPUT/patch-${PRGNAM}.log

chown -R root:root .
chmod -R u+w,go+r-w,a+rX-st .

echo Building ...

export CFLAGS="$SLKCFLAGS"
export CXXFLAGS="$SLKCFLAGS"
export LDFLAGS="$SLKLDFLAGS"

[ ! -x configure ] && ./autogen.sh

./configure \
  --prefix=/usr \
  --localstatedir=/var \
  --sysconfdir=/etc \
  --mandir=/usr/man \
  --program-prefix= \
  --program-suffix= \
  --build=$TARGET \
  2>&1 | tee $OUTPUT/configure-${PRGNAM}.log

make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
make DESTDIR=$PKG install 2>&1 |tee $OUTPUT/install-${PRGNAM}.log

# Documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cp -a $SRCDIR/$(basename $0) $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s)
find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;

# Strip binaries
find $PKG | xargs file | grep -e "executable" -e "shared object" \
  | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null

# Package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}

